<?php
namespace Pangira\Easylink\Controller;

/***
 *
 * This file is part of the "easyLink" Extension for TYPO3 CMS.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 *  (c) 2019
 *
 ***/

/**
 * EasylinkController
 */
class EasylinkController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController
{
    /**
     * easylinkRepository
     *
     * @var \Pangira\Easylink\Domain\Repository\EasylinkRepository
     * @inject
     */
    protected $easylinkRepository = null;

    /**
     * action list
     *
     * @return void
     */
    public function listAction()
    {
        $cacheTimeInMinutes = 1440; // in Minuten 1440 => 24h
        $currentdomain = $this->uriBuilder->getRequest()->getRequestUri();
        $currentdomain = explode('/', $currentdomain)[2];
        $type          = $this->settings['type'];
        $lang          = $this->settings['language'];
        $apikey        = $this->settings['apikey'];
        $downloadlink  = 'https://er' . $type . '.net/'.$apikey.'/'.$lang.'/'.$currentdomain.'.html'; 
        // Cache Handling
        $dir           = \TYPO3\CMS\Core\Utility\GeneralUtility::getFileAbsFileName('uploads/tx_easylink/');
        $file          = 'easy_dse_' . $lang . '_' . $currentdomain . '.html';
        $lastmodified  = 0;
        $ret           = '';
        if (isset($_REQUEST['cache']) && ($_REQUEST['cache'] == 0)) {
            @unlink($dir.$file);
            // Serveraufruf sicherstellen, selbst, wenn das Löschen fehl schlägt
        } else {
            $lastmodified = (file_exists($dir.$file) ? @filemtime($dir.$file) : 0); // 0 oder unixtimestamp
        }
        $now           = date('U');
        $doLiveUpdate  = 1;
        // lade aus Cache, wenn vorhanden und cache zeit noch nicht rum
        if ($lastmodified && (($now - $lastmodified) / 60) < $cacheTimeInMinutes) {
            // lade gecachte DSE
            $ret = @file_get_contents($dir.$file);
            if ($ret) {
                $doLiveUpdate = 0;
                $ret .= "\n<!-- gecachte Version " . $dir.$file . ' vom ' . date('d.m.Y H:i:s', $lastmodified) . ' -->';
            }
        }
        if ($doLiveUpdate) {
            $context = stream_context_create(array('http' => array('ignore_errors' => 1, 'timeout' => 10)));
            $response = @file_get_contents($downloadlink, false, $context);
            if (strpos($http_response_header[0], "200")) { 
               $ret = $response;
            } else {
               $ret = print_r($response, 1);
               if (!preg_match('/error/i', $ret)) {
                 $ret = 0; 
               }
            }         
            if (!$ret) {
              // versuche doch die gecachte DSE, weil Serverfehler oder cachetime rum
              $ret = @file_get_contents($dir.$file);
              if (!$ret) {
                  $ret = "Error TY#0 Datenschutzerklärung fehlt";
              } else {
                  $ret .= "\n<!-- gecachte Version " . $dir.$file . ' vom ' . date('d.m.Y H:i:s', $lastmodified) . ' -->';
              }
            } else {
                // speichere DSE
                @file_put_contents($dir.$file, $ret);
            }
        }
        $this->view->assign('response', $ret);
    }
}